%name C99_STD_GenParser
%define INHERIT : public Parser
//%define ENUM_TOKEN 1  // ==> generates error: parse error before numeric constant, missing ';' before right brace
%define USE_CONST_TOKEN 1
%define LSP_NEEDED
%define ERROR_BODY = 0
%define LEX_BODY = 0
%define LTYPE c99_std_ltype_t

%header{
#include "defs.h"
#include <string>
#include <iostream>
#include <fstream>
#include "Parser.h"

using std::string;

typedef struct
{
	int first_line;
	int last_line;
	int first_column;
	int last_column;
	unsigned char * text;
} c99_std_ltype_t;

%}

%union
{
	char identifier[SYNTAX_TOKEN_SIZE];
	char character;
}

%type <character> '['
%type <character> ']'
%type <character> '{'
%type <character> '}'
%type <character> '('
%type <character> ')'
%type <character> '<'
%type <character> '>'

%token <identifier> AUTO                           300
%token <identifier> BREAK                          301
%token <identifier> CASE                           302
%token <identifier> CHAR                           303
%token <identifier> CONST                          304
%token <identifier> CONTINUE                       305
%token <identifier> DEFAULT                        306
%token <identifier> DO                             307
%token <identifier> DOUBLE                         308
%token <identifier> ELSE                           309
%token <identifier> ENUM                           310
%token <identifier> EXTERN                         311
%token <identifier> FLOAT                          312
%token <identifier> FOR                            313
%token <identifier> GOTO                           314
%token <identifier> IF                             315
%token <identifier> INLINE                         316
%token <identifier> INT                            317
%token <identifier> LONG                           318
%token <identifier> REGISTER                       319
%token <identifier> RESTRICT                       320
%token <identifier> RETURN                         321
%token <identifier> SHORT                          322
%token <identifier> SIGNED                         323
%token <identifier> SIZEOF                         324
%token <identifier> STATIC                         325
%token <identifier> STRUCT                         326
%token <identifier> SWITCH                         327
%token <identifier> TYPEDEF                        328
%token <identifier> UNION                          329
%token <identifier> UNSIGNED                       330
%token <identifier> VOID                           331
%token <identifier> VOLATILE                       332
%token <identifier> WHILE                          333
%token <identifier> _BOOL                          334
%token <identifier> _COMPLEX                       335
%token <identifier> _IMAGINARY                     336
%token <identifier> ELLIPSIS                       337
%token <identifier> DART                           338
%token <identifier> LS_ASSIGN                      339
%token <identifier> RS_ASSIGN                      340
%token <identifier> MUL_ASSIGN                     341
%token <identifier> DIV_ASSIGN                     342
%token <identifier> ADD_ASSIGN                     343
%token <identifier> SUB_ASSIGN                     344
%token <identifier> NEG_ASSIGN                     345
%token <identifier> XOR_ASSIGN                     346
%token <identifier> AND_ASSIGN                     347
%token <identifier> OR_ASSIGN                      348
%token <identifier> MOD_ASSIGN                     349
%token <identifier> EQ_COMPARE                     350
%token <identifier> NE_COMPARE                     351
%token <identifier> LE_COMPARE                     352
%token <identifier> GE_COMPARE                     353
%token <identifier> INCREMENT                      354
%token <identifier> DECREMENT                      355
%token <identifier> LOGICAL_AND                    356
%token <identifier> LOGICAL_OR                     357
%token <identifier> LS                             358
%token <identifier> RS                             359
%token <identifier> IDENTIFIER                     360
%token <identifier> TYPE_NAME                      361
%token <identifier> DECIMAL_CONSTANT               362
%token <identifier> HEXADECIMAL_CONSTANT           363
%token <identifier> OCTAL_CONSTANT                 364
%token <identifier> UNIVERSAL_CHARACTER_NAME       365
%token <identifier> DECIMAL_FLOAT_CONSTANT         366
%token <identifier> HEXADECIMAL_FLOAT_CONSTANT     367
%token <identifier> STRING                         368
%token <identifier> CHARACTER_SEQUENCE             369
%token <character>  NOT                            370
%token <character>  NEG                            371
%token <character>  MINUS                          372
%token <character>  PLUS                           373
%token <character>  STAR                           374
%token <character>  AND                            375
%token <character>  ASSIGN                         376
%token <character>  SEMICOLON                      377
%token <character>  COLON                          378
%token <character>  COMMA                          379
%token <character>  POINT                          380
%token <character>  XOR                            381
%token <character>  OR                             382
%token <character>  QUOTE                          383
%token <character>  SLASH                          384
%token <character>  MOD                            385
%token <character>  QUESTION                       386
%token <character>  BACKSLASH                      387
%token              PARENTHESIS_LEFT               388
%token              PARENTHESIS_RIGHT              389
%token              BRACKET_LEFT                   390
%token              BRACKET_RIGHT                  391
%token              BRACE_LEFT                     392
%token              BRACE_RIGHT                    393
%token              CLAMP_LEFT                     394
%token              CLAMP_RIGHT                    395
%token              LABEL                          396
%token              EXPRESSION                     397
%token              DIRECT_DECLARATOR              398
%token              TYPE_SPECIFIER                 399
%token              DECLARATION_SPECIFIERS         400
%token              PARAMETER_DECLARATION          401
%token              PARAMETER_LIST                 402
%token              PARAMETER_TYPE_LIST            403
%token              DECLARATOR                     404
%token              INIT_DECLARATOR_LIST           405
%token              DECLARATION                    406
%token              EXTERNAL_DECLARATION           407
%token              TRANSLATION_UNIT               408
%token              INIT_DECLARATOR                409
%token              BLOCK_ITEM_LIST                410
%token              BLOCK_ITEM                     411
%token              FUNCTION_DEFINITION            412
%token              PRIMARY_EXPRESSION             413
%token              ARGUMENT_EXPRESSION_LIST       414
%token              ASSIGNMENT_EXPRESSION          415
%token              POSTFIX_EXPRESSION             416
%token              UNARY_EXPRESSION               417
%token              CAST_EXPRESSION                418
%token              MULTIPLICATIVE_EXPRESSION      419
%token              ADDITIVE_EXPRESSION            420
%token              SHIFT_EXPRESSION               421
%token              RELATIONAL_EXPRESSION          422
%token              AND_EXPRESSION                 423
%token              EXCLUSIVE_OR_EXPRESSION        424
%token              INCLUSIVE_OR_EXPRESSION        425
%token              LOGICAL_AND_EXPRESSION         426
%token              LOGICAL_OR_EXPRESSION          427
%token              CONDITIONAL_EXPRESSION         428
%token              STORAGE_CLASS_SPECIFIER        429
%token              STRUCT_OR_UNION_SPECIFIER      430
%token              STATEMENT                      431
%token              EXPRESSION_STATEMENT           432
%token              COMPOUND_STATEMENT             433
%token              SELECTION_STATEMENT            434
%token              LABELED_STATEMENT              435
%token              JUMP_STATEMENT                 436
%token              ITERATION_STATEMENT            437
%token              POINTER                        438
%token              CONSTANT                       439
%token              SPECIFIER_QUALIFIER_LIST       440
%token              ENUM_SPECIFIER                 441
%token              FUNCTION_SPECIFIER             442
%token              TYPE_QUALIFIER                 443
%token              TYPE_QUALIFIER_LIST            444
%token              INITIALIZER_LIST               445
%token              DESIGNATOR_LIST                446
%token              IDENTIFIER_LIST                447
%token              ENUMERATOR                     448
%token              DECLARATION_LIST               449
%token              ENUMERATOR_LIST                450
%token              DIRECT_ABSTRACT_DECLARATOR     451
%token              STRUCT_DECLARATION             452
%token              STRUCT_DECLARATION_LIST        453
%token              STRUCT_DECLARATOR              454
%token              STRUCT_DECLARATOR_LIST         455
%token              PARAMETER                      456
%token              INITIALIZER                    457
%token              DESIGNATION                    458
%token              DESIGNATOR                     459
%token              CONSTANT_EXPRESSION            460
%token              INTRINSIC_EXPRESSION           461

%start translation_unit

%%

constant
: DECIMAL_CONSTANT
	{
		tree->push(new Node(DECIMAL_CONSTANT, $1, module()));
	}
| HEXADECIMAL_CONSTANT
	{
		tree->push(new Node(HEXADECIMAL_CONSTANT, $1, module()));
	}
| OCTAL_CONSTANT
	{
		tree->push(new Node(OCTAL_CONSTANT, $1, module()));
	}
| DECIMAL_FLOAT_CONSTANT
	{
		tree->push(new Node(DECIMAL_FLOAT_CONSTANT, $1, module()));
	}
| HEXADECIMAL_FLOAT_CONSTANT
	{
		tree->push(new Node(HEXADECIMAL_FLOAT_CONSTANT, $1, module()));
	}
| CHARACTER_SEQUENCE
	{
		tree->push(new Node(CHARACTER_SEQUENCE, $1, module()));
	}
;

string_expression
: STRING
	{
		tree->push(new Node(STRING, $1, module()));
	}
| string_expression STRING
	{
		Node * str = tree->pop();
		tree->push(new Node(STRING, (str->identifier()+$2).c_str(), module()));
		delete str;
	}
;

primary_expression
: constant
	{
		Node * node = new Node(CONSTANT, module());
		node->add_front(tree->pop());
		tree->push(node);
	}
| '(' expression ')'
	{
		Node * node = new Node(PRIMARY_EXPRESSION, module());
		node->add_front(PARENTHESIS_RIGHT, $3);
		node->add_front(tree->pop());
		node->add_front(PARENTHESIS_LEFT, $1);
		tree->push(node);
	}
| string_expression
	{
	}
| IDENTIFIER
	{
		tree->push(new Node(IDENTIFIER, $1, module()));
	}
;

postfix_expression
: primary_expression
	{
	}
| postfix_expression INCREMENT
	{
		Node * node = new Node(POSTFIX_EXPRESSION, module());
		node->add_front(INCREMENT, $2);
		node->add_front(tree->pop());
		tree->push(node);
	}
| postfix_expression DECREMENT
	{
		Node * node = new Node(POSTFIX_EXPRESSION, module());
		node->add_front(DECREMENT, $2);
		node->add_front(tree->pop());
		tree->push(node);
	}
| postfix_expression DART IDENTIFIER
	{
		Node * node = new Node(POSTFIX_EXPRESSION, module());
		node->add_front(IDENTIFIER,$3);
		node->add_front(DART, $2);
		node->add_front(tree->pop());
		tree->push(node);
	}
| postfix_expression POINT IDENTIFIER
	{
		Node * node = new Node(POSTFIX_EXPRESSION,module());
		node->add_front(IDENTIFIER, $3);
		node->add_front(POINT, $2);
		node->add_front(tree->pop());
		tree->push(node);
	}
| postfix_expression '[' expression ']'
	{
		Node * node = new Node(POSTFIX_EXPRESSION, module());
		node->add_front(BRACKET_RIGHT, $4);
		node->add_front(tree->pop());
		node->add_front(BRACKET_LEFT, $2);
		node->add_front(tree->pop());
		tree->push(node);
	}
| postfix_expression '(' ')'
	{
		Node * node = new Node(POSTFIX_EXPRESSION, module());
		node->add_front(PARENTHESIS_RIGHT, $3);
		node->add_front(PARENTHESIS_LEFT, $2);
		node->add_front(tree->pop());
		tree->push(node);
	}
| postfix_expression '(' argument_expression_list ')'
	{
		Node * node = new Node(POSTFIX_EXPRESSION, module());
		node->add_front(PARENTHESIS_RIGHT, $4);
		node->add_front(tree->pop());
		node->add_front(PARENTHESIS_LEFT, $2);
		node->add_front(tree->pop());
		tree->push(node);
	}
| '(' type_name ')' '{' initializer_list '}'
	{
		Node * node = new Node(POSTFIX_EXPRESSION, module());
		node->add_front(BRACE_RIGHT, $6);
		node->add_front(tree->pop());
		node->add_front(BRACE_LEFT, $4);
		node->add_front(PARENTHESIS_RIGHT, $3);
		node->add_front(tree->pop());
		node->add_front(PARENTHESIS_LEFT, $1);
		tree->push(node);
	}
| '(' type_name ')' '{' initializer_list COMMA '}'
	{
		Node * node = new Node(POSTFIX_EXPRESSION, module());
		node->add_front(BRACE_RIGHT, $7);
		node->add_front(COMMA, $6);
		node->add_front(tree->pop());
		node->add_front(BRACE_LEFT, $4);
		node->add_front(PARENTHESIS_RIGHT, $3);
		node->add_front(tree->pop());
		node->add_front(PARENTHESIS_LEFT, $1);
		tree->push(node);
	}
;

argument_expression_list
: assignment_expression
	{
	}
| argument_expression_list COMMA assignment_expression
	{
		Node * expr = tree->pop();
		Node * list = tree->pop();
		if (list->is_type(ARGUMENT_EXPRESSION_LIST))
		{
			list->add_back(COMMA, $2);
			list->add_back(expr);
			tree->push(list);
		}
		else
		{
			Node * tmp = new Node(ARGUMENT_EXPRESSION_LIST, module());
			tmp->add_back(list);
			tmp->add_back(COMMA, $2);
			tmp->add_back(expr);
			tree->push(tmp);
		}
	}
;

unary_expression
: postfix_expression
	{
	}
| INCREMENT unary_expression
	{
		Node * node = new Node(UNARY_EXPRESSION, module());
		node->add_front(tree->pop());
		node->add_front(INCREMENT, $1);
		tree->push(node);
	}
| DECREMENT unary_expression
	{
		Node * node = new Node(UNARY_EXPRESSION, module());
		node->add_front(tree->pop());
		node->add_front(DECREMENT, $1);
		tree->push(node);
	}
| unary_operator cast_expression
	{
		Node * node = new Node(UNARY_EXPRESSION, module());
		node->add_front(tree->pop());
		node->add_front(tree->pop());
		tree->push(node);
	}
| SIZEOF unary_expression
	{
		Node * node = new Node(UNARY_EXPRESSION, module());
		node->add_front(tree->pop());
		node->add_front(SIZEOF, $1);
		tree->push(node);
	}
| SIZEOF '(' type_name ')'
	{
		Node * node = new Node(UNARY_EXPRESSION, module());
		node->add_front(PARENTHESIS_RIGHT, $4);
		node->add_front(tree->pop());
		node->add_front(PARENTHESIS_LEFT, $2);
		node->add_front(SIZEOF, $1);
		tree->push(node);
	}
;

unary_operator
: AND
	{
		tree->push(new Node(AND, $1, module()));
	}
| STAR
	{
		tree->push(new Node(STAR, $1, module()));
	}
| PLUS
	{
		tree->push(new Node(PLUS, $1, module()));
	}
| MINUS
	{
		tree->push(new Node(MINUS, $1, module()));
	}
| NEG
	{
		tree->push(new Node(NEG,  $1, module()));
	}
| NOT
	{
		tree->push(new Node(NOT, $1, module()));
	}
;

cast_expression
: unary_expression
	{
	}
| '(' type_name ')' cast_expression
	{
		Node * node = new Node(EXPRESSION, module());
		node->add_front(tree->pop());
		node->add_front(PARENTHESIS_RIGHT, $3);
		node->add_front(tree->pop());
		node->add_front(PARENTHESIS_LEFT, $1);
		tree->push(node);
	}
;

multiplicative_expression
: cast_expression
	{
	}
| multiplicative_expression STAR cast_expression
	{
		Node * node = new Node(STAR, $2, module());
		node->add_front(tree->pop());
		node->add_front(tree->pop());
		tree->push(node);
	}
| multiplicative_expression SLASH cast_expression
	{
		Node * node = new Node(SLASH, $2, module());
		node->add_front(tree->pop());
		node->add_front(tree->pop());
		tree->push(node);
	}
| multiplicative_expression MOD cast_expression
	{
		Node * node = new Node(MOD, $2, module());
		node->add_front(tree->pop());
		node->add_front(tree->pop());
		tree->push(node);
	}
;

additive_expression
: multiplicative_expression
	{
	}
| additive_expression PLUS multiplicative_expression
	{
		Node * node = new Node(PLUS, $2, module());
		node->add_front(tree->pop());
		node->add_front(tree->pop());
		tree->push(node);
	}
| additive_expression MINUS multiplicative_expression
	{
		Node * node = new Node(MINUS, $2, module());
		node->add_front(tree->pop());
		node->add_front(tree->pop());
		tree->push(node);
	}
;

shift_expression
: additive_expression
	{
	}
| shift_expression LS additive_expression
	{
		Node * node = new Node(LS, $2, module());
		node->add_front(tree->pop());
		node->add_front(tree->pop());
		tree->push(node);
	}
| shift_expression RS additive_expression
	{
		Node * node = new Node(RS, $2, module());
		node->add_front(tree->pop());
		node->add_front(tree->pop());
		tree->push(node);
	}
;

relational_expression
: shift_expression
	{
	}
| relational_expression '<' shift_expression
	{
		Node * node = new Node(CLAMP_LEFT, $2, module());
		node->add_front(tree->pop());
		node->add_front(tree->pop());
		tree->push(node);
	}
| relational_expression '>' shift_expression
	{
		Node * node = new Node(CLAMP_RIGHT, $2, module());
		node->add_front(tree->pop());
		node->add_front(tree->pop());
		tree->push(node);
	}
| relational_expression LE_COMPARE shift_expression
	{
		Node * node = new Node(LE_COMPARE, $2, module());
		node->add_front(tree->pop());
		node->add_front(tree->pop());
		tree->push(node);
	}
| relational_expression GE_COMPARE shift_expression
	{
		Node * node = new Node(GE_COMPARE, $2, module());
		node->add_front(tree->pop());
		node->add_front(tree->pop());
		tree->push(node);
	}
;

equality_expression
: relational_expression
	{
	}
| equality_expression EQ_COMPARE relational_expression
	{
		Node * node = new Node(EQ_COMPARE, $2, module());
		node->add_front(tree->pop());
		node->add_front(tree->pop());
		tree->push(node);
	}
| equality_expression NE_COMPARE relational_expression
	{
		Node * node = new Node(NE_COMPARE, $2, module());
		node->add_front(tree->pop());
		node->add_front(tree->pop());
		tree->push(node);
	}
;

and_expression
: equality_expression
	{
	}
| and_expression AND equality_expression
	{
		Node * node = new Node(AND,$2, module());
		node->add_front(tree->pop());
		node->add_front(tree->pop());
		tree->push(node);
	}
;

exclusive_or_expression
: and_expression
	{
	}
| exclusive_or_expression XOR and_expression
	{
		Node * node = new Node(XOR, $2, module());
		node->add_front(tree->pop());
		node->add_front(tree->pop());
		tree->push(node);
	}
;

inclusive_or_expression
: exclusive_or_expression
	{
	}
| inclusive_or_expression OR exclusive_or_expression
	{
		Node * node = new Node(OR, $2, module());
		node->add_front(tree->pop());
		node->add_front(tree->pop());
		tree->push(node);
	}
;

logical_and_expression
: inclusive_or_expression
	{
	}
| logical_and_expression LOGICAL_AND inclusive_or_expression
	{
		Node * node = new Node(LOGICAL_AND, $2, module());
		node->add_front(tree->pop());
		node->add_front(tree->pop());
		tree->push(node);
	}
;

logical_or_expression
: logical_and_expression
	{
	}
| logical_or_expression LOGICAL_OR logical_and_expression
	{
		Node * node = new Node(LOGICAL_OR, $2, module());
		node->add_front(tree->pop());
		node->add_front(tree->pop());
		tree->push(node);
	}
;

conditional_expression
: logical_or_expression
	{
	}
| logical_or_expression QUESTION expression COLON conditional_expression
	{
		Node * node = new Node(EXPRESSION,  module());
		node->add_front(tree->pop());
		node->add_front(COLON, $4);
		node->add_front(tree->pop());
		node->add_front(QUESTION, $2);
		node->add_front(tree->pop());
		tree->push(node);
	}
;


assignment_expression
: conditional_expression
	{
	}
| unary_expression assignment_operator assignment_expression
	{
		Node * assign_expr = tree->pop();
		Node * assign_op   = tree->pop();
		Node * unary_expr  = tree->pop();
		assign_op->add_front(assign_expr);
		assign_op->add_front(unary_expr);
		tree->push(assign_op);
	}
;

assignment_operator
: ASSIGN
	{
		tree->push(new Node(ASSIGN, $1, module()));
	}
| MUL_ASSIGN
	{
		tree->push(new Node(MUL_ASSIGN, $1, module()));
	}
| DIV_ASSIGN
	{
		tree->push(new Node(DIV_ASSIGN, $1, module()));
	}
| MOD_ASSIGN
	{
		tree->push(new Node(MOD_ASSIGN, $1, module()));
	}
| ADD_ASSIGN
	{
		tree->push(new Node(ADD_ASSIGN, $1, module()));
	}
| SUB_ASSIGN
	{
		tree->push(new Node(SUB_ASSIGN, $1, module()));
	}
| LS_ASSIGN
	{
		tree->push(new Node(LS_ASSIGN, $1, module()));
	}
| RS_ASSIGN
	{
		tree->push(new Node(RS_ASSIGN, $1, module()));
	}
| AND_ASSIGN
	{
		tree->push(new Node(AND_ASSIGN, $1, module()));
	}
| XOR_ASSIGN
	{
		tree->push(new Node(XOR_ASSIGN, $1, module()));
	}
| OR_ASSIGN
	{
		tree->push(new Node(OR_ASSIGN, $1, module()));
	}
;

expression
: assignment_expression
	{
	}
| expression COMMA assignment_expression
	{
		Node * node = new Node(EXPRESSION, module());
		node->add_front(tree->pop());
		node->add_front(COMMA, $2);
		node->add_front(tree->pop());
		tree->push(node);
	}
;

type_name
: specifier_qualifier_list
	{
		Node * node = new Node(SPECIFIER_QUALIFIER_LIST, module());
		node->add_front(tree->pop());
		tree->push(node);
	}
| specifier_qualifier_list abstract_declarator
	{
		Node * node = new Node(TYPE_NAME, module());
		node->add_front(tree->pop());
		node->add_front(tree->pop());
		tree->push(node);
	}
;

specifier_qualifier_list
: type_specifier
	{
	}
| type_specifier specifier_qualifier_list
	{
		Node * node = new Node(SPECIFIER_QUALIFIER_LIST, module());
		node->add_front(tree->pop());
		node->add_front(tree->pop());
		tree->push(node);
	}
| type_qualifier
	{
	}
| type_qualifier specifier_qualifier_list
	{
		Node * node = new Node(SPECIFIER_QUALIFIER_LIST, module());
		node->add_front(tree->pop());
		node->add_front(tree->pop());
		tree->push(node);
	}
;

type_specifier
: VOID
	{
		tree->push(new Node(VOID, $1, module()));
	}
| CHAR
	{
		tree->push(new Node(CHAR, $1, module()));
	}
| SHORT
	{
		tree->push(new Node(SHORT, $1, module()));
	}
| INT
	{
		tree->push(new Node(INT, $1, module()));
	}
| LONG
	{
		tree->push(new Node(LONG, $1, module()));
	}
| FLOAT
	{
		tree->push(new Node(FLOAT, $1, module()));
	}
| DOUBLE
	{
		tree->push(new Node(DOUBLE, $1, module()));
	}
| SIGNED
	{
		tree->push(new Node(SIGNED, $1, module()));
	}
| UNSIGNED
	{
		tree->push(new Node(UNSIGNED, $1, module()));
	}
| _BOOL
	{
		tree->push(new Node(_BOOL, $1, module()));
	}
| _COMPLEX
	{
		tree->push(new Node(_COMPLEX, $1, module()));
	}
| _IMAGINARY
	{
		tree->push(new Node(_IMAGINARY, $1, module()));
	}
| TYPE_NAME
	{
		tree->push(new Node(TYPE_NAME, $1, module()));
	}
| struct_or_union_specifier
	{
	}
| enum_specifier
	{
	}
;

type_qualifier
: CONST
	{
		tree->push(new Node(CONST, $1, module()));
	}
| RESTRICT
	{
		tree->push(new Node(RESTRICT, $1, module()));
	}
| VOLATILE
	{
		tree->push(new Node(VOLATILE, $1, module()));
	}
;

statement
: compound_statement
	{
	}
| selection_statement
	{
	}
| expression_statement
	{
	}
| labeled_statement
	{
	}
| jump_statement
	{
	}
| iteration_statement
	{
	}
;

expression_statement
: SEMICOLON
	{
		tree->push(new Node(SEMICOLON, $1, module()));
	}
| expression SEMICOLON
	{
		Node * node = new Node(EXPRESSION_STATEMENT, module());
		node->add_front(SEMICOLON, $2);
		node->add_front(tree->pop());
		tree->push(node);
	}
;

compound_statement
: '{' block_item_list '}'
	{
		Node * node = new Node(COMPOUND_STATEMENT, module());
		node->add_front(BRACE_RIGHT, $3);
		node->add_front(tree->pop());
		node->add_front(BRACE_LEFT, $1);
		tree->push(node);
	}
| '{' '}'
	{
		Node * node = new Node(COMPOUND_STATEMENT, module());
		node->add_front(BRACE_RIGHT, $2);
		node->add_front(BRACE_LEFT, $1);
		tree->push(node);
	}
;

block_item_list
: block_item
	{
	}
| block_item_list block_item
	{
		Node * node = tree->pop();
		Node * list = tree->pop();
		if (list->is_type(BLOCK_ITEM_LIST))
		{
			list->add_back(node);
			tree->push(list);
		}
		else
		{
			Node * tmp = new Node(BLOCK_ITEM_LIST, module());
			tmp->add_front(node);
			tmp->add_front(list);
			tree->push(tmp);
		}
	}
;

block_item
: declaration
	{
	}
| statement
	{
	}
;

selection_statement
: IF '(' expression ')' statement
	{
		Node * node = new Node(SELECTION_STATEMENT, module());
		node->add_front(tree->pop());
		node->add_front(PARENTHESIS_RIGHT, $4);
		node->add_front(tree->pop());
		node->add_front(PARENTHESIS_LEFT, $2);
		node->add_front(IF, $1);
		tree->push(node);
	}
| IF '(' expression ')' statement ELSE statement
	{
		Node * node = new Node(SELECTION_STATEMENT, module());
		node->add_front(tree->pop());
		node->add_front(ELSE, $6);
		node->add_front(tree->pop());
		node->add_front(PARENTHESIS_RIGHT, $4);
		node->add_front(tree->pop());
		node->add_front(PARENTHESIS_LEFT, $2);
		node->add_front(IF, $1);
		tree->push(node);
	}
| SWITCH '(' expression ')' statement
	{
		Node * node = new Node(SELECTION_STATEMENT, module());
		node->add_front(tree->pop());
		node->add_front(PARENTHESIS_RIGHT, $4);
		node->add_front(tree->pop());
		node->add_front(PARENTHESIS_LEFT, $4);
		node->add_front(SWITCH, $1);
		tree->push(node);
	}
;

labeled_statement
: CASE constant_expression COLON statement
	{
		Node * node = new Node(LABELED_STATEMENT, module());
		node->add_front(tree->pop());
		node->add_front(COLON, $3);
		node->add_front(tree->pop());
		node->add_front(CASE, $1);
		tree->push(node);
	}
| DEFAULT COLON statement
	{
		Node * node = new Node(LABELED_STATEMENT, module());
		node->add_front(tree->pop());
		node->add_front(COLON, $2);
		node->add_front(DEFAULT, $1);
		tree->push(node);
	}
| IDENTIFIER COLON statement
	{
		Node * node = new Node(LABELED_STATEMENT, module());
		node->add_front(tree->pop());
		node->add_front(COLON, $2);
		node->add_front(IDENTIFIER, $1);
		tree->push(node);
	}
;

jump_statement
: GOTO IDENTIFIER SEMICOLON
	{
		Node * node = new Node(JUMP_STATEMENT, module());
		node->add_front(SEMICOLON, $3);
		node->add_front(IDENTIFIER, $2);
		node->add_front(GOTO, $1);
		tree->push(node);
	}
| CONTINUE SEMICOLON
	{
		Node * node = new Node(JUMP_STATEMENT, module());
		node->add_front(SEMICOLON, $2);
		node->add_front(CONTINUE, $1);
		tree->push(node);
	}
| BREAK SEMICOLON
	{
		Node * node = new Node(JUMP_STATEMENT, module());
		node->add_front(SEMICOLON, $2);
		node->add_front(BREAK, $1);
		tree->push(node);
	}
| RETURN SEMICOLON
	{
		Node * node = new Node(JUMP_STATEMENT, module());
		node->add_front(SEMICOLON, $2);
		node->add_front(RETURN, $1);
		tree->push(node);
	}
| RETURN expression SEMICOLON
	{
		Node * node = new Node(JUMP_STATEMENT, module());
		node->add_front(SEMICOLON, $3);
		node->add_front(tree->pop());
		node->add_front(RETURN, $1);
		tree->push(node);
	}
;

constant_expression
: conditional_expression
	{
		Node * node = new Node(CONSTANT_EXPRESSION, module());
		node->add_front(tree->pop());
		tree->push(node);
	}
;

iteration_statement
: WHILE '(' expression ')' statement
	{
		Node * node = new Node(ITERATION_STATEMENT, module());
		node->add_front(tree->pop());
		node->add_front(PARENTHESIS_RIGHT, $4);
		node->add_front(tree->pop());
		node->add_front(PARENTHESIS_LEFT, $2);
		node->add_front(WHILE, $1);
		tree->push(node);
	}
| DO statement WHILE '(' expression ')' SEMICOLON
	{
		Node * node = new Node(ITERATION_STATEMENT, module());
		node->add_front(SEMICOLON, $7);
		node->add_front(PARENTHESIS_RIGHT, $6);
		node->add_front(tree->pop());
		node->add_front(PARENTHESIS_LEFT, $4);
		node->add_front(WHILE, $3);
		node->add_front(tree->pop());
		node->add_front(DO, $1);
		tree->push(node);
	}
| FOR '(' SEMICOLON SEMICOLON ')' statement
	{
		Node * node = new Node(ITERATION_STATEMENT, module());
		node->add_front(tree->pop());
		node->add_front(PARENTHESIS_RIGHT, $5);
		node->add_front(SEMICOLON, $4);
		node->add_front(SEMICOLON, $3);
		node->add_front(PARENTHESIS_LEFT, $2);
		node->add_front(FOR, $1);
		tree->push(node);
	}
| FOR '(' SEMICOLON SEMICOLON expression ')' statement
	{
		Node * node = new Node(ITERATION_STATEMENT, module());
		node->add_front(tree->pop());
		node->add_front(PARENTHESIS_RIGHT, $6);
		node->add_front(tree->pop());
		node->add_front(SEMICOLON, $4);
		node->add_front(SEMICOLON, $3);
		node->add_front(PARENTHESIS_LEFT, $2);
		node->add_front(FOR, $1);
		tree->push(node);
	}
| FOR '(' SEMICOLON expression SEMICOLON ')' statement
	{
		Node * node = new Node(ITERATION_STATEMENT, module());
		node->add_front(tree->pop());
		node->add_front(PARENTHESIS_RIGHT, $6);
		node->add_front(SEMICOLON, $5);
		node->add_front(tree->pop());
		node->add_front(SEMICOLON, $3);
		node->add_front(PARENTHESIS_LEFT, $2);
		node->add_front(FOR, $1);
		tree->push(node);
	}
| FOR '(' SEMICOLON expression SEMICOLON expression ')' statement
	{
		Node * node = new Node(ITERATION_STATEMENT, module());
		node->add_front(tree->pop());
		node->add_front(PARENTHESIS_RIGHT, $7);
		node->add_front(tree->pop());
		node->add_front(SEMICOLON, $5);
		node->add_front(tree->pop());
		node->add_front(SEMICOLON, $3);
		node->add_front(PARENTHESIS_LEFT, $2);
		node->add_front(FOR, $1);
		tree->push(node);
	}
| FOR '(' expression SEMICOLON SEMICOLON ')' statement
	{
		Node * node = new Node(ITERATION_STATEMENT, module());
		node->add_front(tree->pop());
		node->add_front(PARENTHESIS_RIGHT, $6);
		node->add_front(SEMICOLON, $5);
		node->add_front(SEMICOLON, $4);
		node->add_front(tree->pop());
		node->add_front(PARENTHESIS_LEFT, $2);
		node->add_front(FOR, $1);
		tree->push(node);
	}
| FOR '(' expression SEMICOLON SEMICOLON expression ')' statement
	{
		Node * node = new Node(ITERATION_STATEMENT, module());
		node->add_front(tree->pop());
		node->add_front(PARENTHESIS_RIGHT, $7);
		node->add_front(tree->pop());
		node->add_front(SEMICOLON, $5);
		node->add_front(SEMICOLON, $4);
		node->add_front(tree->pop());
		node->add_front(PARENTHESIS_LEFT, $2);
		node->add_front(FOR, $1);
		tree->push(node);
	}
| FOR '(' expression SEMICOLON expression SEMICOLON ')' statement
	{
		Node * node = new Node(ITERATION_STATEMENT, module());
		node->add_front(tree->pop());
		node->add_front(PARENTHESIS_RIGHT, $7);
		node->add_front(SEMICOLON, $6);
		node->add_front(tree->pop());
		node->add_front(SEMICOLON, $4);
		node->add_front(tree->pop());
		node->add_front(PARENTHESIS_LEFT, $2);
		node->add_front(FOR, $1);
		tree->push(node);
	}
| FOR '(' expression SEMICOLON expression SEMICOLON expression ')' statement
	{
		Node * node = new Node(ITERATION_STATEMENT, module());
		node->add_front(tree->pop());
		node->add_front(PARENTHESIS_RIGHT, $8);
		node->add_front(tree->pop());
		node->add_front(SEMICOLON, $6);
		node->add_front(tree->pop());
		node->add_front(SEMICOLON, $4);
		node->add_front(tree->pop());
		node->add_front(PARENTHESIS_LEFT, $2);
		node->add_front(FOR, $1);
		tree->push(node);
	}
| FOR '(' declaration SEMICOLON ')' statement
	{
		Node * node = new Node(ITERATION_STATEMENT, module());
		node->add_front(tree->pop());
		node->add_front(PARENTHESIS_RIGHT, $5);
		node->add_front(SEMICOLON, $4);
		node->add_front(tree->pop());
		node->add_front(PARENTHESIS_LEFT, $2);
		node->add_front(FOR, $1);
		tree->push(node);
	}
| FOR '(' declaration expression SEMICOLON ')' statement
	{
		Node * node = new Node(ITERATION_STATEMENT, module());
		node->add_front(tree->pop());
		node->add_front(PARENTHESIS_RIGHT, $6);
		node->add_front(SEMICOLON, $5);
		node->add_front(tree->pop());
		node->add_front(tree->pop());
		node->add_front(PARENTHESIS_LEFT, $2);
		node->add_front(FOR, $1);
		tree->push(node);
	}
| FOR '(' declaration SEMICOLON expression ')' statement
	{
		Node * node = new Node(ITERATION_STATEMENT, module());
		node->add_front(tree->pop());
		node->add_front(PARENTHESIS_RIGHT, $6);
		node->add_front(tree->pop());
		node->add_front(SEMICOLON, $4);
		node->add_front(tree->pop());
		node->add_front(PARENTHESIS_LEFT, $2);
		node->add_front(FOR, $1);
		tree->push(node);
	}
| FOR '(' declaration expression SEMICOLON expression ')' statement
	{
		Node * node = new Node(ITERATION_STATEMENT, module());
		node->add_front(tree->pop());
		node->add_front(PARENTHESIS_RIGHT, $7);
		node->add_front(tree->pop());
		node->add_front(SEMICOLON, $5);
		node->add_front(tree->pop());
		node->add_front(tree->pop());
		node->add_front(PARENTHESIS_LEFT, $2);
		node->add_front(FOR, $1);
		tree->push(node);
	}
;

declaration
: declaration_specifiers init_declarator_list SEMICOLON
	{
		Node * decl = tree->pop();
		Node * spec = tree->pop();
		Node * node = new Node(DECLARATION, module());
		node->add_front(SEMICOLON, $3);
		node->add_front(decl);
		node->add_front(spec);
		tree->push(node);
		check_for_type_name(spec, decl);
	}
| declaration_specifiers SEMICOLON
	{
		Node * node = new Node(DECLARATION, module());
		node->add_front(SEMICOLON, $2);
		node->add_front(tree->pop());
		tree->push(node);
	}
;

declaration_specifiers
: storage_class_specifier
	{
		Node * t = tree->pop();
		if (t->is_type(DECLARATION_SPECIFIERS)) tree->push(t);
		else
		{
			Node * node = new Node(DECLARATION_SPECIFIERS, module());
			node->add_front(t);
			tree->push(node);
		}
	}
| type_specifier
	{
		Node * t = tree->pop();
		if (t->is_type(DECLARATION_SPECIFIERS)) tree->push(t);
		else
		{
			Node * node = new Node(DECLARATION_SPECIFIERS, module());
			node->add_front(t);
			tree->push(node);
		}
	}
| type_qualifier
	{
		Node * t = tree->pop();
		if (t->is_type(DECLARATION_SPECIFIERS)) tree->push(t);
		else
		{
			Node * node = new Node(DECLARATION_SPECIFIERS, module());
			node->add_front(t);
			tree->push(node);
		}
	}
| function_specifier
	{
		Node * t = tree->pop();
		if (t->is_type(DECLARATION_SPECIFIERS)) tree->push(t);
		else
		{
			Node * node = new Node(DECLARATION_SPECIFIERS, module());
			node->add_front(t);
			tree->push(node);
		}
	}
| storage_class_specifier declaration_specifiers
	{
		Node * node = tree->pop();
		node->add_front(tree->pop());
		tree->push(node);
	}
| type_specifier declaration_specifiers
	{
		Node * node = tree->pop();
		node->add_front(tree->pop());
		tree->push(node);
	}
| type_qualifier declaration_specifiers
	{
		Node * node = tree->pop();
		node->add_front(tree->pop());
		tree->push(node);
	}
| function_specifier declaration_specifiers
	{
		Node * node = tree->pop();
		node->add_front(tree->pop());
		tree->push(node);
	}
;

storage_class_specifier
: EXTERN
	{
		tree->push(new Node(EXTERN, $1, module()));
	}
| STATIC
	{
		tree->push(new Node(STATIC, $1, module()));
	}
| AUTO
	{
		tree->push(new Node(AUTO, $1, module()));
	}
| REGISTER
	{
		tree->push(new Node(REGISTER, $1, module()));
	}
| TYPEDEF
	{
		tree->push(new Node(TYPEDEF, $1, module()));
	}
;

init_declarator_list
: init_declarator
	{
	}
| init_declarator_list COMMA init_declarator
	{
		Node * idec = tree->pop();
		Node * list = tree->pop();
		if (list->is_type(INIT_DECLARATOR_LIST))
		{
			list->add_back(COMMA, $2);
			list->add_back(idec);
			tree->push(list);
		}
		else
		{
			Node * tmp = new Node(INIT_DECLARATOR_LIST, module());
			tmp->add_back(list);
			tmp->add_back(COMMA, $2);
			tmp->add_back(idec);
			tree->push(tmp);
		}
	}
;

init_declarator
: declarator
	{
	}
| declarator ASSIGN initializer
	{
		Node * node = new Node(INIT_DECLARATOR, module());
		node->add_front(tree->pop());
		node->add_front(ASSIGN, $2);
		node->add_front(tree->pop());
		tree->push(node);
	}
;

declarator
: direct_declarator
	{
	}
| pointer direct_declarator
	{
		Node * node = new Node(DECLARATOR, module());
		node->add_front(tree->pop());
		node->add_front(tree->pop());
		tree->push(node);
	}
;

pointer
: STAR
	{
		tree->push(new Node(STAR, $1, module()));
	}
| STAR pointer
	{
		Node * node = new Node(POINTER, module());
		node->add_front(tree->pop());
		node->add_front(STAR, $1);
		tree->push(node);
	}
| STAR type_qualifier_list
	{
		Node * node = new Node(POINTER, module());
		node->add_front(tree->pop());
		node->add_front(STAR, $1);
		tree->push(node);
	}
| STAR type_qualifier_list pointer
	{
		Node * node = new Node(POINTER, module());
		node->add_front(tree->pop());
		node->add_front(tree->pop());
		node->add_front(STAR, $1);
		tree->push(node);
	}
;

initializer
: assignment_expression
	{
		Node * node = new Node(INITIALIZER, module());
		node->add_front(tree->pop());
		tree->push(node);
	}
| '{' initializer_list '}'
	{
		Node * node = new Node(INITIALIZER, module());
		node->add_front(BRACE_RIGHT, $3);
		node->add_front(tree->pop());
		node->add_front(BRACE_LEFT, $1);
		tree->push(node);
	}
| '{' initializer_list COMMA '}'
	{
		Node * node = new Node(INITIALIZER, module());
		node->add_front(BRACE_RIGHT, $4);
		node->add_front(COMMA, $3);
		node->add_front(tree->pop());
		node->add_front(BRACE_LEFT, $1);
		tree->push(node);
	}
;

direct_declarator
: '(' declarator ')'
	{
		Node * node = new Node(DIRECT_DECLARATOR, module());
		node->add_front(PARENTHESIS_RIGHT, $3);
		node->add_front(tree->pop());
		node->add_front(PARENTHESIS_LEFT, $1);
		tree->push(node);
	}
| direct_declarator '(' ')'
	{
		Node * node = new Node(DIRECT_DECLARATOR, module());
		node->add_front(PARENTHESIS_RIGHT,  $3);
		node->add_front(PARENTHESIS_LEFT,  $2);
		node->add_front(tree->pop());
		tree->push(node);
	}
| direct_declarator '(' identifier_list ')'
	{
		Node * node = new Node(DIRECT_DECLARATOR,  module());
		node->add_front(PARENTHESIS_RIGHT, $4);
		node->add_front(tree->pop());
		node->add_front(PARENTHESIS_LEFT, $2);
		node->add_front(tree->pop());
		tree->push(node);
	}
| direct_declarator '(' parameter_type_list ')'
	{
		Node * node = new Node(DIRECT_DECLARATOR, module());
		node->add_front(PARENTHESIS_RIGHT, $4);
		node->add_front(tree->pop());
		node->add_front(PARENTHESIS_LEFT, $2);
		node->add_front(tree->pop());
		tree->push(node);
	}
| direct_declarator '[' ']'
	{
		Node * node = new Node(DIRECT_DECLARATOR, module());
		node->add_front(BRACKET_RIGHT, $3);
		node->add_front(BRACKET_LEFT, $2);
		node->add_front(tree->pop());
		tree->push(node);
	}
| direct_declarator '[' STAR ']'
	{
		Node * node = new Node(DIRECT_DECLARATOR, module());
		node->add_front(BRACKET_RIGHT, $4);
		node->add_front(STAR, $3);
		node->add_front(BRACKET_LEFT, $2);
		node->add_front(tree->pop());
		tree->push(node);
	}
| direct_declarator '[' type_qualifier_list STAR ']'
	{
		Node * node = new Node(DIRECT_DECLARATOR, module());
		node->add_front(BRACKET_RIGHT, $5);
		node->add_front(STAR, $4);
		node->add_front(tree->pop());
		node->add_front(BRACKET_LEFT, $2);
		node->add_front(tree->pop());
		tree->push(node);
	}
| direct_declarator '[' type_qualifier_list STATIC assignment_expression ']'
	{
		Node * node = new Node(DIRECT_DECLARATOR, module());
		node->add_front(BRACKET_RIGHT, $6);
		node->add_front(tree->pop());
		node->add_front(STATIC, $4);
		node->add_front(tree->pop());
		node->add_front(BRACKET_LEFT,  $2);
		node->add_front(tree->pop());
		tree->push(node);
	}
| direct_declarator '[' STATIC assignment_expression ']'
	{
		Node * node = new Node(DIRECT_DECLARATOR, module());
		node->add_front(BRACKET_RIGHT, $5);
		node->add_front(tree->pop());
		node->add_front(STATIC, $3);
		node->add_front(BRACKET_LEFT, $2);
		node->add_front(tree->pop());
		tree->push(node);
	}
| direct_declarator '[' STATIC type_qualifier_list assignment_expression ']'
	{
		Node * node = new Node(DIRECT_DECLARATOR, module());
		node->add_front(BRACKET_RIGHT, $6);
		node->add_front(tree->pop());
		node->add_front(tree->pop());
		node->add_front(STATIC, $3);
		node->add_front(BRACKET_LEFT, $2);
		node->add_front(tree->pop());
		tree->push(node);
	}
| direct_declarator '[' type_qualifier_list assignment_expression ']'
	{
		Node * node = new Node(DIRECT_DECLARATOR, module());
		node->add_front(BRACKET_RIGHT, $5);
		node->add_front(tree->pop());
		node->add_front(tree->pop());
		node->add_front(BRACKET_LEFT, $2);
		node->add_front(tree->pop());
		tree->push(node);
	}
| direct_declarator '[' assignment_expression ']'
	{
		Node * node = new Node(DIRECT_DECLARATOR, module());
		node->add_front(BRACKET_RIGHT, $4);
		node->add_front(tree->pop());
		node->add_front(BRACKET_LEFT, $2);
		node->add_front(tree->pop());
		tree->push(node);
	}
| direct_declarator '[' type_qualifier_list ']'
	{
		Node * node = new Node(DIRECT_DECLARATOR, module());
		node->add_front(BRACKET_RIGHT, $4);
		node->add_front(tree->pop());
		node->add_front(BRACKET_LEFT, $2);
		node->add_front(tree->pop());
		tree->push(node);
	}
| IDENTIFIER
	{
		tree->push(new Node(IDENTIFIER, $1, module()));
	}
;

parameter_type_list
: parameter_list
	{
	}
| parameter_list COMMA ELLIPSIS
	{
		Node * list = tree->pop();
		if (list->is_type(PARAMETER_LIST))
		{
			list->add_back(COMMA, $2);
			list->add_back(ELLIPSIS, $3);
			tree->push(list);
		}
		else
		{
			Node * tmp = new Node(PARAMETER_LIST, module());
			tmp->add_back(list);
			tmp->add_back(COMMA, $2);
			tmp->add_back(ELLIPSIS, $3);
			tree->push(tmp);
		}
	}
;

parameter_list
: parameter_declaration
	{
	}
| parameter_list COMMA parameter_declaration
	{
		Node * decl = tree->pop();
		Node * list = tree->pop();
		if (list->is_type(PARAMETER_LIST))
		{
			list->add_back(COMMA, $2);
			list->add_back(decl);
			tree->push(list);
		}
		else
		{
			Node * tmp = new Node(PARAMETER_LIST, module());
			tmp->add_back(list);
			tmp->add_back(COMMA, $2);
			tmp->add_back(decl);
			tree->push(tmp);
		}
	}
;

parameter_declaration
: declaration_specifiers
	{
		Node * node = new Node(PARAMETER,  module());
		node->add_front(tree->pop());
		tree->push(node);
	}
| declaration_specifiers declarator
	{
		Node * node = new Node(PARAMETER,  module());
		node->add_front(tree->pop());
		node->add_front(tree->pop());
		tree->push(node);
	}
| declaration_specifiers abstract_declarator
	{
		Node * node = new Node(PARAMETER,  module());
		node->add_front(tree->pop());
		node->add_front(tree->pop());
		tree->push(node);
	}
;

type_qualifier_list
: type_qualifier
	{
		Node * node = new Node(TYPE_QUALIFIER_LIST, module());
		node->add_front(tree->pop());
		tree->push(node);
	}
| type_qualifier_list type_qualifier
	{
		Node * qual = tree->pop();
		Node * list = tree->pop();
		if (list->is_type(TYPE_QUALIFIER_LIST))
		{
			list->add_back(qual);
			tree->push(list);
		}
		else
		{
			Node * tmp = new Node(TYPE_QUALIFIER_LIST, module());
			tmp->add_back(list);
			tmp->add_back(qual);
			tree->push(tmp);
		}
	}
;

initializer_list
: initializer
	{
	}
| designation initializer
	{
		Node * node = new Node(INITIALIZER_LIST, module());
		node->add_front(tree->pop());
		node->add_front(tree->pop());
		tree->push(node);
	}
| initializer_list COMMA initializer
	{
		Node * init = tree->pop();
		Node * list = tree->pop();
		if (list->is_type(INITIALIZER_LIST))
		{
			list->add_back(COMMA, $2);
			list->add_back(init);
			tree->push(list);
		}
		else
		{
			Node * tmp = new Node(INITIALIZER_LIST, module());
			tmp->add_back(list);
			tmp->add_back(COMMA, $2);
			tmp->add_back(init);
			tree->push(tmp);
		}
	}
| initializer_list COMMA designation initializer
	{
		Node * init = tree->pop();
		Node * desi = tree->pop();
		Node * list = tree->pop();
		if (list->is_type(INITIALIZER_LIST))
		{
			list->add_back(COMMA, $2);
			list->add_back(desi);
			list->add_back(init);
			tree->push(list);
		}
		else
		{
			Node * tmp = new Node(INITIALIZER_LIST, module());
			tmp->add_back(COMMA, $2);
			tmp->add_back(desi);
			tmp->add_back(init);
			tree->push(tmp);
		}
	}
;

designation
: designator_list ASSIGN
	{
		Node * node = new Node(DESIGNATION, module());
		node->add_front(ASSIGN);
		node->add_front(tree->pop());
		tree->push(node);
	}
;

designator_list
: designator
	{
	}
| designator_list designator
	{
		Node * desi = tree->pop();
		Node * list = tree->pop();
		if (list->is_type(DESIGNATOR_LIST))
		{
			list->add_back(desi);
			tree->push(list);
		}
		else
		{
			Node * tmp = new Node(DESIGNATOR_LIST, module());
			tmp->add_back(list);
			tmp->add_back(desi);
			tree->push(tmp);
		}
	}
;

designator
: '[' constant_expression ']'
	{
		Node * node = new Node(DESIGNATOR, module());
		node->add_front(BRACKET_RIGHT, $3);
		node->add_front(tree->pop());
		node->add_front(BRACKET_LEFT, $1);
		tree->push(node);
	}
| POINT IDENTIFIER
	{
		Node * node = new Node(DESIGNATOR, module());
		node->add_front(IDENTIFIER, $2);
		node->add_front(POINT, $1);
		tree->push(node);
	}
;

identifier_list
: IDENTIFIER
	{
		tree->push(new Node(IDENTIFIER, $1, module()));
	}
| identifier_list COMMA IDENTIFIER
	{
		Node * list = tree->pop();
		if (list->is_type(IDENTIFIER_LIST))
		{
			list->add_back(COMMA, $2);
			list->add_back(IDENTIFIER, $3);
			tree->push(list);
		}
		else
		{
			Node * tmp = new Node(IDENTIFIER_LIST, module());
			tmp->add_back(list);
			tmp->add_back(COMMA, $2);
			tmp->add_back(IDENTIFIER, $3);
			tree->push(tmp);
		}
	}
;

abstract_declarator
: pointer
	{
		Node * node = new Node(POINTER, module());
		node->add_front(tree->pop());
		tree->push(node);
	}
| direct_abstract_declarator
	{
		Node * node = new Node(DIRECT_ABSTRACT_DECLARATOR, module());
		node->add_front(tree->pop());
		tree->push(node);
	}
| pointer direct_abstract_declarator
	{
		Node * node = new Node(DIRECT_ABSTRACT_DECLARATOR, module());
		node->add_front(tree->pop());
		node->add_front(tree->pop());
		tree->push(node);
	}
;

direct_abstract_declarator
: '(' abstract_declarator ')'
	{
		Node * node = new Node(DIRECT_ABSTRACT_DECLARATOR, module());
		node->add_front(PARENTHESIS_RIGHT, $3);
		node->add_front(tree->pop());
		node->add_front(PARENTHESIS_LEFT, $1);
		tree->push(node);
	}
| '(' ')'
	{
		Node * node = new Node(DIRECT_ABSTRACT_DECLARATOR, module());
		node->add_front(PARENTHESIS_RIGHT, $2);
		node->add_front(PARENTHESIS_LEFT, $1);
		tree->push(node);
	}
| '(' parameter_type_list ')'
	{
		Node * node = new Node(DIRECT_ABSTRACT_DECLARATOR, module());
		node->add_front(PARENTHESIS_RIGHT, $3);
		node->add_front(tree->pop());
		node->add_front(PARENTHESIS_LEFT, $1);
		tree->push(node);
	}
| '[' ']'
	{
		Node * node = new Node(DIRECT_ABSTRACT_DECLARATOR, module());
		node->add_front(BRACKET_RIGHT, $2);
		node->add_front(BRACKET_LEFT, $1);
		tree->push(node);
	}
| '[' STAR ']'
	{
		Node * node = new Node(DIRECT_ABSTRACT_DECLARATOR, module());
		node->add_front(BRACKET_RIGHT, $3);
		node->add_front(STAR, $2);
		node->add_front(BRACKET_LEFT, $1);
		tree->push(node);
	}
| '[' assignment_expression ']'
	{
		Node * node = new Node(DIRECT_ABSTRACT_DECLARATOR, module());
		node->add_front(BRACKET_RIGHT, $3);
		node->add_front(tree->pop());
		node->add_front(BRACKET_LEFT, $1);
		tree->push(node);
	}
| direct_abstract_declarator '[' ']'
	{
		Node * node = new Node(DIRECT_ABSTRACT_DECLARATOR, module());
		node->add_front(BRACKET_RIGHT, $3);
		node->add_front(BRACKET_LEFT, $2);
		node->add_front(tree->pop());
		tree->push(node);
	}
| direct_abstract_declarator '[' STAR ']'
	{
		Node * node = new Node(DIRECT_ABSTRACT_DECLARATOR, module());
		node->add_front(BRACKET_RIGHT, $4);
		node->add_front(STAR, $3);
		node->add_front(BRACKET_LEFT, $2);
		node->add_front(tree->pop());
		tree->push(node);
	}
| direct_abstract_declarator '[' assignment_expression ']'
	{
		Node * node = new Node(DIRECT_ABSTRACT_DECLARATOR, module());
		node->add_front(BRACKET_RIGHT, $4);
		node->add_front(tree->pop());
		node->add_front(BRACKET_LEFT, $2);
		node->add_front(tree->pop());
		tree->push(node);
	}
| direct_abstract_declarator '(' ')'
	{
		Node * node = new Node(DIRECT_ABSTRACT_DECLARATOR, module());
		node->add_front(PARENTHESIS_RIGHT, $3);
		node->add_front(PARENTHESIS_LEFT, $2);
		node->add_front(tree->pop());
		tree->push(node);
	}
| direct_abstract_declarator '(' parameter_type_list ')'
	{
		Node * node = new Node(DIRECT_ABSTRACT_DECLARATOR, module());
		node->add_front(PARENTHESIS_RIGHT, $4);
		node->add_front(tree->pop());
		node->add_front(PARENTHESIS_LEFT, $2);
		node->add_front(tree->pop());
		tree->push(node);
	}
;

function_specifier
: INLINE
	{
		tree->push(new Node(INLINE, $1, module()));
	}
;

struct_or_union_specifier
: struct_or_union IDENTIFIER
	{
		Node * node = new Node(STRUCT_OR_UNION_SPECIFIER, module());
		node->add_front(IDENTIFIER, $2);
		node->add_front(tree->pop());
		tree->push(node);
	}
| struct_or_union '{' struct_declaration_list '}'
	{
		Node * node = new Node(STRUCT_OR_UNION_SPECIFIER, module());
		node->add_front(BRACE_RIGHT, $4);
		node->add_front(tree->pop());
		node->add_front(BRACE_LEFT, $2);
		node->add_front(tree->pop());
		tree->push(node);
	}
| struct_or_union IDENTIFIER '{' struct_declaration_list '}'
	{
		Node * node = new Node(STRUCT_OR_UNION_SPECIFIER, module());
		node->add_front(BRACE_RIGHT, $5);
		node->add_front(tree->pop());
		node->add_front(BRACE_LEFT, $3);
		node->add_front(IDENTIFIER, $2);
		node->add_front(tree->pop());
		tree->push(node);
	}
;

struct_or_union
: STRUCT
	{
		tree->push(new Node(STRUCT, $1, module()));
	}
| UNION
	{
		tree->push(new Node(UNION, $1, module()));
	}
;

struct_declaration_list
: struct_declaration
	{
	}
| struct_declaration_list struct_declaration
	{
		Node * decl = tree->pop();
		Node * list = tree->pop();
		if (list->is_type(STRUCT_DECLARATION_LIST))
		{
			list->add_back(decl);
			tree->push(list);
		}
		else
		{
			Node * tmp = new Node(STRUCT_DECLARATION_LIST, module());
			tmp->add_back(list);
			tmp->add_back(decl);
			tree->push(tmp);
		}
	}
;

struct_declaration
: specifier_qualifier_list struct_declarator_list SEMICOLON
	{
		Node * node = new Node(STRUCT_DECLARATION, module());
		node->add_front(SEMICOLON, $3);
		node->add_front(tree->pop());
		node->add_front(tree->pop());
		tree->push(node);
	}
;

struct_declarator_list
: struct_declarator
	{
	}
| struct_declarator_list COMMA struct_declarator
	{
		Node * sdec = tree->pop();
		Node * list = tree->pop();
		if (list->is_type(STRUCT_DECLARATOR_LIST))
		{
			list->add_back(COMMA, $2);
			list->add_back(sdec);
			tree->push(list);
		}
		else
		{
			Node * tmp = new Node(STRUCT_DECLARATOR_LIST, module());
			tmp->add_back(list);
			tmp->add_back(COMMA, $2);
			tmp->add_back(sdec);
			tree->push(tmp);
		}
	}
;

struct_declarator
: COLON constant_expression
	{
		Node * node = new Node(STRUCT_DECLARATOR, module());
		node->add_front(tree->pop());
		node->add_front(COLON, $1);
		tree->push(node);
	}
| declarator
	{
	}
| declarator COLON constant_expression
	{
		Node * node = new Node(STRUCT_DECLARATOR, module());
		node->add_front(tree->pop());
		node->add_front(COLON, $2);
		node->add_front(tree->pop());
		tree->push(node);
	}
;

enum_specifier
: ENUM '{' enumerator_list '}'
	{
		Node * node = new Node(ENUM_SPECIFIER, module());
		node->add_front(BRACE_RIGHT, $4);
		node->add_front(tree->pop());
		node->add_front(BRACE_LEFT, $2);
		node->add_front(ENUM, $1);
		tree->push(node);
	}
| ENUM '{' enumerator_list COMMA '}'
	{
		Node * node = new Node(ENUM_SPECIFIER, module());
		node->add_front(BRACE_RIGHT, $5);
		node->add_front(COMMA, $4);
		node->add_front(tree->pop());
		node->add_front(BRACE_LEFT, $2);
		node->add_front(ENUM, $1);
		tree->push(node);
	}
| ENUM IDENTIFIER
	{
		Node * node = new Node(ENUM_SPECIFIER, module());
		node->add_front(IDENTIFIER, $2);
		node->add_front(ENUM, $1);
		tree->push(node);
	}
| ENUM IDENTIFIER '{' enumerator_list '}'
	{
		Node * node = new Node(ENUM_SPECIFIER, module());
		node->add_front(BRACE_RIGHT, $5);
		node->add_front(tree->pop());
		node->add_front(BRACE_LEFT, $3);
		node->add_front(IDENTIFIER, $2);
		node->add_front(ENUM, $1);
		tree->push(node);
	}
| ENUM IDENTIFIER '{' enumerator_list COMMA '}'
	{
		Node * node = new Node(ENUM_SPECIFIER, module());
		node->add_front(BRACE_RIGHT, $6);
		node->add_front(COMMA, $5);
		node->add_front(tree->pop());
		node->add_front(BRACE_LEFT, $3);
		node->add_front(IDENTIFIER, $2);
		node->add_front(ENUM, $1);
		tree->push(node);
	}
;

enumerator_list
: enumerator
	{
	}
| enumerator_list COMMA enumerator
	{
		Node * enu  = tree->pop();
		Node * list = tree->pop();
		if (list->is_type(ENUMERATOR_LIST))
		{
			list->add_back(COMMA, $2);
			list->add_back(enu);
			tree->push(list);
		}
		else
		{
			Node * tmp = new Node(ENUMERATOR_LIST, module());
			tmp->add_back(list);
			tmp->add_back(COMMA, $2);
			tmp->add_back(enu);
			tree->push(tmp);
		}
	}
;

enumerator
: IDENTIFIER
	{
		Node * node = new Node(ENUMERATOR, module());
		node->add_front(IDENTIFIER, $1);
		tree->push(node);
	}
| IDENTIFIER ASSIGN constant_expression
	{
		Node * node = new Node(ENUMERATOR, module());
		node->add_front(tree->pop());
		node->add_front(ASSIGN);
		node->add_front(IDENTIFIER);
		tree->push(node);
	}
;

declaration_list
: declaration
	{
	}
| declaration_list declaration
	{
		Node * decl = tree->pop();
		Node * list = tree->pop();
		if (list->is_type(DECLARATION_LIST))
		{
			list->add_back(decl);
			tree->push(list);
		}
		else
		{
			Node * tmp = new Node(DECLARATION_LIST, module());
			tmp->add_back(list);
			tmp->add_back(decl);
			tree->push(tmp);
		}
	}
;

function_definition
: declaration_specifiers declarator compound_statement
	{
		Node * node = new Node(FUNCTION_DEFINITION, module());
		node->add_front(tree->pop());
		node->add_front(tree->pop());
		node->add_front(tree->pop());
		tree->push(node);
	}
| declaration_specifiers declarator declaration_list compound_statement
	{
		Node * node = new Node(FUNCTION_DEFINITION, module());
		node->add_front(tree->pop());
		node->add_front(tree->pop());
		node->add_front(tree->pop());
		node->add_front(tree->pop());
		tree->push(node);
	}
;

external_declaration
: function_definition
	{
	}
| declaration
	{
	}
;

translation_unit
: external_declaration
	{
	}
| translation_unit external_declaration
	{
	}
;

%%
