%name C99_Tasking64_GenScanner
%define INHERIT : public Scanner
%define MEMBERS public: virtual void init(void) { init_scanner(); yy_initialize(); }
%define IOSTREAM
%define LEX_PARAM YY_C99_Tasking64_GenParser_STYPE *val, YY_C99_Tasking64_GenParser_LTYPE *loc

%header{
#include <sstream>
#include "Scanner.h"
#include "C99_Tasking64_GenParser.h"

#define LOG(t)		do { count(t); } while (0)
%}

%x COMMENT
%x ASSEMBLER

IS				(([uU]([lL]|"ll"|"LL")?)|([lL][uU]?)|(("ll"|"LL")[uU]?))
D				[0-9]
D0				[1-9]
A				[_a-zA-Z]
AD				[_a-zA-Z0-9]
H				[0-9a-fA-F]
O				[0-7]

%%

"/*"	{
		LOG(yytext);
		BEGIN COMMENT;
	}
"//".*\n	{
		++line;
		column = 1;
	}

<COMMENT>"*/"	{
		LOG(yytext);
		BEGIN 0;
	}
<COMMENT>\n	{
		++line;
		column = 1;
	}
<COMMENT>.	{
		++column;
	}

"auto"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::AUTO;
	}
"break"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::BREAK;
	}
"case"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::CASE;
	}
"char"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::CHAR;
	}
"const"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::CONST;
	}
"continue"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::CONTINUE;
	}
"default"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::DEFAULT;
	}
"do"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::DO;
	}
"double"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::DOUBLE;
	}
"else"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::ELSE;
	}
"enum"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::ENUM;
	}
"extern"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::EXTERN;
	}
"float"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::FLOAT;
	}
"for"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::FOR;
	}
"goto"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::GOTO;
	}
"if"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::IF;
	}
"inline"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::INLINE;
	}
"int"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::INT;
	}
"long"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::LONG;
	}
"register"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::REGISTER;
	}
"restrict"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::RESTRICT;
	}
"return"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::RETURN;
	}
"short"		{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::SHORT;
	}
"signed"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::SIGNED;
	}
"sizeof"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::SIZEOF;
	}
"static"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::STATIC;
	}
"struct"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::STRUCT;
	}
"switch"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::SWITCH;
	}
"typedef"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::TYPEDEF;
	}
"union"		{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::UNION;
	}
"unsigned"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::UNSIGNED;
	}
"void"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::VOID;
	}
"volatile"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::VOLATILE;
	}
"while"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::WHILE;
	}
"_Bool"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::_BOOL;
	}
"_Complex"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::_COMPLEX;
	}
"_Imaginary"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::_IMAGINARY;
	}
"_bit"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::_BIT;
	}
"bit"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::BIT;
	}
"_bita"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::_BITA;
	}
"_bitword"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::_BITWORD;
	}
"_sfrbit"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::_SFRBIT;
	}
"_esfrbit"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::_ESFRBIT;
	}
"_sfr"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::_SFR;
	}
"_esfr"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::_ESFR;
	}
"_at"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::_AT;
	}
"_atbit"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::_ATBIT;
	}
"_inline"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::_INLINE;
	}
"_usm"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::_USM;
	}
"_nousm"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::_NOUSM;
	}
"_near"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::_NEAR;
	}
"_far"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::_FAR;
	}
"_huge"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::_HUGE;
	}
"_shuge"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::_SHUGE;
	}
"near"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::TOK_NEAR;
	}
"far"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::TOK_FAR;
	}
"huge"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::TOK_HUGE;
	}
"shuge"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::TOK_SHUGE;
	}
"_system"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::_SYSTEM;
	}
"_iram"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::_IRAM;
	}
"_getbit"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::_GETBIT;
	}
"_putbit"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::_PUTBIT;
	}
"_interrupt"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::_INTERRUPT;
	}
"_using"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::_USING;
	}
"interrupt"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::_INTERRUPT;
	}
"using"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::USING;
	}
"_rol"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::_ROL;
	}
"_ror"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::_ROR;
	}
"_testclear"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::_TESTCLEAR;
	}
"_testset"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::_TESTSET;
	}
"_bfld"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::_BFLD;
	}
"_int166"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::_INT166;
	}
"_idle"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::_IDLE;
	}
"_nop"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::_NOP;
	}
"_prior"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::_PRIOR;
	}
"_pwrdn"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::_PWRDN;
	}
"_srvwdt"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::_SRVWDT;
	}
"_diswdt"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::_DISWDT;
	}
"_einit"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::_EINIT;
	}
"_atomic"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::_ATOMIC;
	}
"_mul32"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::_MUL32;
	}
"_mulu32"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::_MULU32;
	}
"_div32"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::_DIV32;
	}
"_divu32"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::_DIVU32;
	}
"_mod32"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::_MOD32;
	}
"_modu32"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::_MODU32;
	}
"_pag"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::_PAG;
	}
"_pof"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::_POF;
	}
"_seg"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::_SEG;
	}
"_sof"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::_SOF;
	}
"_mkfp"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::_MKFP;
	}
"_mkhp"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::_MKHP;
	}
"_mksp"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::_MKSP;
	}
"bank"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::BANK;
	}
"sfr"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::SFR;
	}
"esfr"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::ESFR;
	}
"sfrbit"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::SFRBIT;
	}
"esfrbit"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::ESFRBIT;
	}
"..."	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::ELLIPSIS; 
	}
"<<="	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::LS_ASSIGN;
	}
">>="	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::RS_ASSIGN;
	}
"->"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::DART;
	}
"=="	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::EQ_COMPARE;
	}
"!="	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::NE_COMPARE;
	}
">="	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::GE_COMPARE;
	}
"<="	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::LE_COMPARE;
	}
"~="	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::NEG_ASSIGN;
	}
"+="	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::ADD_ASSIGN;
	}
"*="	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::MUL_ASSIGN;
	}
"/="	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::DIV_ASSIGN;
	}
"%="	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::MOD_ASSIGN;
	}
"-="	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::SUB_ASSIGN;
	}
"^="	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::XOR_ASSIGN;
	}
"&="	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::AND_ASSIGN;
	}
"|="	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::OR_ASSIGN;
	}
"++"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::INCREMENT;
	}
"--"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::DECREMENT;
	}
"&&"	{ 
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::LOGICAL_AND;
	}
"||"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::LOGICAL_OR;
	}
"<<"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::LS;
	}
">>"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::RS;
	}
"="	{
		LOG(yytext);
		memset(val->identifier, 0, SYNTAX_TOKEN_SIZE);
		val->character = yytext[0];
		return C99_Tasking64_GenParser::ASSIGN;
	}
";"	{
		LOG(yytext);
		memset(val->identifier, 0, SYNTAX_TOKEN_SIZE);
		val->character = yytext[0];
		return C99_Tasking64_GenParser::SEMICOLON;
	}
":"	{
		LOG(yytext);
		memset(val->identifier, 0, SYNTAX_TOKEN_SIZE);
		val->character = yytext[0];
		return C99_Tasking64_GenParser::COLON;
	}
","	{
		LOG(yytext);
		memset(val->identifier, 0, SYNTAX_TOKEN_SIZE);
		val->character = yytext[0];
		return C99_Tasking64_GenParser::COMMA;
	}
"."	{
		LOG(yytext);
		memset(val->identifier, 0, SYNTAX_TOKEN_SIZE);
		val->character = yytext[0];
		return C99_Tasking64_GenParser::POINT;
	}
"&"	{
		LOG(yytext);
		memset(val->identifier, 0, SYNTAX_TOKEN_SIZE);
		val->character = yytext[0];
		return C99_Tasking64_GenParser::AND;
	}
"|"	{
		LOG(yytext);
		memset(val->identifier, 0, SYNTAX_TOKEN_SIZE);
		val->character = yytext[0];
		return C99_Tasking64_GenParser::OR;
	}
"~"	{
		LOG(yytext);
		memset(val->identifier, 0, SYNTAX_TOKEN_SIZE);
		val->character = yytext[0];
		return C99_Tasking64_GenParser::NEG;
	}
"^"	{
		LOG(yytext);
		memset(val->identifier, 0, SYNTAX_TOKEN_SIZE);
		val->character = yytext[0];
		return C99_Tasking64_GenParser::XOR;
	}
"!"	{
		LOG(yytext);
		memset(val->identifier, 0, SYNTAX_TOKEN_SIZE);
		val->character = yytext[0];
		return C99_Tasking64_GenParser::NOT;
	}
"\""	{
		LOG(yytext);
		memset(val->identifier, 0, SYNTAX_TOKEN_SIZE);
		val->character = yytext[0];
		return '"';
	}
"'"	{
		LOG(yytext);
		memset(val->identifier, 0, SYNTAX_TOKEN_SIZE);
		val->character = yytext[0];
		return C99_Tasking64_GenParser::QUOTE; }
"+"	{
		LOG(yytext);
		memset(val->identifier, 0, SYNTAX_TOKEN_SIZE);
		val->character = yytext[0];
		return C99_Tasking64_GenParser::PLUS; }
"*"	{
		LOG(yytext);
		memset(val->identifier, 0, SYNTAX_TOKEN_SIZE);
		val->character = yytext[0];
		return C99_Tasking64_GenParser::STAR; }
"-"	{
		LOG(yytext);
		memset(val->identifier, 0, SYNTAX_TOKEN_SIZE);
		val->character = yytext[0];
		return C99_Tasking64_GenParser::MINUS; }
"/"	{
		LOG(yytext);
		memset(val->identifier, 0, SYNTAX_TOKEN_SIZE);
		val->character = yytext[0];
		return C99_Tasking64_GenParser::SLASH; }
"%"	{
		LOG(yytext);
		memset(val->identifier, 0, SYNTAX_TOKEN_SIZE);
		val->character = yytext[0];
		return C99_Tasking64_GenParser::MOD; }
"?"	{
		LOG(yytext);
		memset(val->identifier, 0, SYNTAX_TOKEN_SIZE);
		val->character = yytext[0];
		return C99_Tasking64_GenParser::QUESTION; }
"\\"	{
		LOG(yytext);
		memset(val->identifier, 0, SYNTAX_TOKEN_SIZE);
		val->character = yytext[0];
		return C99_Tasking64_GenParser::BACKSLASH;
	}
"["|"<:"	{
		LOG(yytext);
		memset(val->identifier, 0, SYNTAX_TOKEN_SIZE);
		val->character = yytext[0];
		return '[';
	}
"]"|":>"	{
		LOG(yytext);
		memset(val->identifier, 0, SYNTAX_TOKEN_SIZE);
		val->character = yytext[0];
		return ']';
	}
"{"|"<%"	{
		LOG(yytext);
		memset(val->identifier, 0, SYNTAX_TOKEN_SIZE);
		val->character = yytext[0];
		enter_scope();
		return '{';
	}
"}"|"%>"	{
		LOG(yytext);
		memset(val->identifier, 0, SYNTAX_TOKEN_SIZE);
		val->character = yytext[0];
		leave_scope();
		return '}';
	}
"("	{
		LOG(yytext);
		memset(val->identifier, 0, SYNTAX_TOKEN_SIZE);
		val->character = yytext[0];
		return '(';
	}
")"	{
		LOG(yytext);
		memset(val->identifier, 0, SYNTAX_TOKEN_SIZE);
		val->character = yytext[0];
		return ')';
	}
"<"	{
		LOG(yytext);
		memset(val->identifier, 0, SYNTAX_TOKEN_SIZE);
		val->character = yytext[0];
		return '<';
	}
">"	{
		LOG(yytext);
		memset(val->identifier, 0, SYNTAX_TOKEN_SIZE);
		val->character = yytext[0];
		return '>';
	}
{A}{AD}*	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return check_type(yytext);
	}
(({D0}{D}*)|0){IS}?	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::DECIMAL_CONSTANT;
	}
0[xX]({H})+{IS}?	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::HEXADECIMAL_CONSTANT;
	}
0({O})+{IS}?	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::OCTAL_CONSTANT;
	}
\\[uU]{H}{4}	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::UNIVERSAL_CHARACTER_NAME;
	}
\\[uU]{H}{8}	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::UNIVERSAL_CHARACTER_NAME;
	}
(({D}*\.{D}+)|({D}+\.{D}*))([eE][+-]?{D}*)?[fFlL]?	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::DECIMAL_FLOAT_CONSTANT;
	}
{D}+[eE][+-]?{D}+[fFlL]?	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::DECIMAL_FLOAT_CONSTANT;
	}
0[xX]{H}+[pP][+-]?{D}+[fFlL]?	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::HEXADECIMAL_FLOAT_CONSTANT;
	}
0[xX](({H}*\.{H}+)|({H}+\.))[pP][+-]?{D}+[fFlL]?	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::HEXADECIMAL_FLOAT_CONSTANT;
	}
[L]?\"([^"\n]|"\\\"")*\"	{
		LOG(yytext);
		copy(val->identifier, yytext, SYNTAX_TOKEN_SIZE);
		return C99_Tasking64_GenParser::STRING;
	}
[L]?'[^'\n']+'	{
		LOG(yytext);
		return C99_Tasking64_GenParser::CHARACTER_SEQUENCE;
	}

#pragma[ \t]noclear.*\n	{
		++line;
		column = 1;
	}
#pragma[ \t]clear.*\n	{
		++line;
		column = 1;
	}
#pragma[ \t]class.*\n	{
		++line;
		column = 1;
	}
#pragma[ \t]combine.*\n	{
		++line;
		column = 1;
	}
#pragma[ \t]align.*\n	{
		++line;
		column = 1;
	}
#pragma[ \t]default_attributes.*\n	{
		++line;
		column = 1;
	}
#pragma[ \t]save_attributes.*\n	{
		++line;
		column = 1;
	}
#pragma[ \t]restore_attributes.*\n	{
		++line;
		column = 1;
	}
#pragma[ \t]global.*\n	{
		++line;
		column = 1;
	}
#pragma[ \t]public.*\n	{
		++line;
		column = 1;
	}
#pragma[ \t]static.*\n	{
		++line;
		column = 1;
	}
#pragma[ \t]automatic.*\n	{
		++line;
		column = 1;
	}
#pragma[ \t]iramdata.*\n	{
		++line;
		column = 1;
	}
#pragma[ \t]romdata.*\n	{
		++line;
		column = 1;
	}
#pragma[ \t]noframe.*\n	{
		++line;
		column = 1;
	}
#pragma[ \t]regdef.*\n	{
		++line;
		column = 1;
	}
#pragma[ \t]switch_force_table.*\n	{
		++line;
		column = 1;
	}
#pragma[ \t]switch_smart.*\n	{
		++line;
		column = 1;
	}
#pragma[ \t]switch_tabmem_far.*\n	{
		++line;
		column = 1;
	}
#pragma[ \t]switch_tabmem_near.*\n	{
		++line;
		column = 1;
	}
#pragma[ \t]switch_tabmem_default.*\n	{
		++line;
		column = 1;
	}
#pragma[ \t]asm.*\n	{
		++line;
		column = 1;
		BEGIN ASSEMBLER;
	}
#pragma[ \t]asm_noflush.*\n	{
		++line;
		column = 1;
		BEGIN ASSEMBLER;
	}
<ASSEMBLER>\n	{
		++line;
		column = 1;
	}
<ASSEMBLER>.	{
		++column;
	}
<ASSEMBLER>#pragma[ \t]endasm.*\n	{
		++line;
		column = 1;
		BEGIN 0;
	}

#line[ \t].*\n	{
		// TODO: replace scanf
		int line_no;
		char module[SYNTAX_MODULE_NAME_SIZE];
		LOG(yytext);
		memset(module, 0, SYNTAX_MODULE_NAME_SIZE);
		sscanf(reinterpret_cast<const char *>(yytext), "#line %d %s", &line_no, module);
		set_current_module(module);
		++line;
		column = 1;
	}
#.*\n	{
		std::cerr << "EROROR: unknown preprocessor commands encountered: '" << ((yytext==0)?"":reinterpret_cast<char *>(yytext)) << "'" << std::endl;
		++line;
		column = 1;
	}
\r	{
		LOG(yytext);
	}
\n	{
		++line;
		column = 1;
	}
\t	{
		if (column % tabstop) column += tabstop;
		else column += ((column + tabstop) % tabstop);
	}
" "	{
		LOG(yytext);
	}
\f	{
		LOG(yytext);
		std::cerr << "ERROR: \\f encountered in module '" << get_current_module() << "' on line " << line << std::endl;
	}
<<EOF>>	{
		yyterminate();
	}
.	{
		LOG(yytext);
		std::cerr << "UNKNOWN TOKEN: [" << yytext << " at " << line << ":" << column << std::endl;
	}

%%
