#include "Scanner.h"
#include "stringutils.h"

Scanner::Scanner()
{
	init_scanner();
}

Scanner::~Scanner()
{}

void Scanner::init_scanner()
{
	scope = 0;
	types.clear();
	line = 1;
	column = 1;
	tabstop = 4;
}

void Scanner::set_current_module(const std::string & module)
{
	current_module = module;
	remove_quotes(current_module);
	current_module = replace(current_module, "\\\\", "\\");
}

void Scanner::remove_type_above_scope_level(int level)
{
	bool quit;
	do
	{
		quit = true;
		for (ISMMap::iterator it = types.begin(); it != types.end(); ++it)
			if (it->first >= level)
			{
				types.erase(it->first);
				quit = false;
				break;
			}
	} while (!quit);
}
